org.eclipse.viatra.cep.core.engine.runtime

## Class EnabledNegativeTransitionMatcher

- java.lang.Object
- - org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper
  - - org.eclipse.viatra.query.runtime.api.impl.BaseMatcher<EnabledNegativeTransitionMatch>
    - - org.eclipse.viatra.cep.core.engine.runtime.EnabledNegativeTransitionMatcher

- All Implemented Interfaces:
    ViatraQueryMatcher<EnabledNegativeTransitionMatch>

      public class EnabledNegativeTransitionMatcher
      extends BaseMatcher<EnabledNegativeTransitionMatch>

  Generated pattern matcher API of the org.eclipse.viatra.cep.core.engine.runtime.enabledNegativeTransition pattern, providing pattern-specific query methods.

  Use the pattern matcher on a given model via `on(ViatraQueryEngine)`, e.g. in conjunction with `ViatraQueryEngine#on(Notifier)`.

  Matches of the pattern will be represented as `EnabledNegativeTransitionMatch`.

  Original source: ``

       pattern enabledNegativeTransition(transition : NegativeTransition, eventToken : EventToken, event : Event, automaton : Automaton) {
              find latestEvent(event);
              Event.type(event, eventType);
              neg find transitionWithEventType(transition, eventType);
              NegativeTransition.preState.eventTokens(transition, eventToken);
              neg find eventProcessedByEventToken(event, eventToken);

              Automaton.states(automaton, state);
              State.outTransitions(state, transition);
       }

  See Also:
    `EnabledNegativeTransitionMatch`, `EnabledNegativeTransitionProcessor`, `EnabledNegativeTransitionQuerySpecification`

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `engine, querySpecification`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper

      `backend`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected EnabledNegativeTransitionMatch` | `arrayToMatch(java.lang.Object[] match)` Converts the array representation of a pattern match to an immutable Match object.
    `protected EnabledNegativeTransitionMatch` | `arrayToMatchMutable(java.lang.Object[] match)` Converts the array representation of a pattern match to a mutable Match object.
    `int` | `countMatches(NegativeTransition pTransition, EventToken pEventToken, Event pEvent, Automaton pAutomaton)` Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
    `static EnabledNegativeTransitionMatcher` | `create()`
    `void` | `forEachMatch(NegativeTransition pTransition, EventToken pEventToken, Event pEvent, Automaton pAutomaton, IMatchProcessor<? super EnabledNegativeTransitionMatch> processor)` Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `forOneArbitraryMatch(NegativeTransition pTransition, EventToken pEventToken, Event pEvent, Automaton pAutomaton, IMatchProcessor<? super EnabledNegativeTransitionMatch> processor)` Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `java.util.Collection<EnabledNegativeTransitionMatch>` | `getAllMatches(NegativeTransition pTransition, EventToken pEventToken, Event pEvent, Automaton pAutomaton)` Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
    `java.util.Set<Automaton>` | `getAllValuesOfautomaton()` Retrieve the set of values that occur in matches for automaton.
    `java.util.Set<Automaton>` | `getAllValuesOfautomaton(EnabledNegativeTransitionMatch partialMatch)` Retrieve the set of values that occur in matches for automaton.
    `java.util.Set<Automaton>` | `getAllValuesOfautomaton(NegativeTransition pTransition, EventToken pEventToken, Event pEvent)` Retrieve the set of values that occur in matches for automaton.
    `java.util.Set<Event>` | `getAllValuesOfevent()` Retrieve the set of values that occur in matches for event.
    `java.util.Set<Event>` | `getAllValuesOfevent(EnabledNegativeTransitionMatch partialMatch)` Retrieve the set of values that occur in matches for event.
    `java.util.Set<Event>` | `getAllValuesOfevent(NegativeTransition pTransition, EventToken pEventToken, Automaton pAutomaton)` Retrieve the set of values that occur in matches for event.
    `java.util.Set<EventToken>` | `getAllValuesOfeventToken()` Retrieve the set of values that occur in matches for eventToken.
    `java.util.Set<EventToken>` | `getAllValuesOfeventToken(EnabledNegativeTransitionMatch partialMatch)` Retrieve the set of values that occur in matches for eventToken.
    `java.util.Set<EventToken>` | `getAllValuesOfeventToken(NegativeTransition pTransition, Event pEvent, Automaton pAutomaton)` Retrieve the set of values that occur in matches for eventToken.
    `java.util.Set<NegativeTransition>` | `getAllValuesOftransition()` Retrieve the set of values that occur in matches for transition.
    `java.util.Set<NegativeTransition>` | `getAllValuesOftransition(EnabledNegativeTransitionMatch partialMatch)` Retrieve the set of values that occur in matches for transition.
    `java.util.Set<NegativeTransition>` | `getAllValuesOftransition(EventToken pEventToken, Event pEvent, Automaton pAutomaton)` Retrieve the set of values that occur in matches for transition.
    `EnabledNegativeTransitionMatch` | `getOneArbitraryMatch(NegativeTransition pTransition, EventToken pEventToken, Event pEvent, Automaton pAutomaton)` Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `hasMatch(NegativeTransition pTransition, EventToken pEventToken, Event pEvent, Automaton pAutomaton)` Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
    `EnabledNegativeTransitionMatch` | `newMatch(NegativeTransition pTransition, EventToken pEventToken, Event pEvent, Automaton pAutomaton)` Returns a new (partial) match.
    `static EnabledNegativeTransitionMatcher` | `on(ViatraQueryEngine engine)` Initializes the pattern matcher within an existing VIATRA Query engine.
    `static IQuerySpecification<EnabledNegativeTransitionMatcher>` | `querySpecification()`
    `protected java.util.Set<Automaton>` | `rawAccumulateAllValuesOfautomaton(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for automaton.
    `protected java.util.Set<Event>` | `rawAccumulateAllValuesOfevent(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for event.
    `protected java.util.Set<EventToken>` | `rawAccumulateAllValuesOfeventToken(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for eventToken.
    `protected java.util.Set<NegativeTransition>` | `rawAccumulateAllValuesOftransition(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for transition.
    `protected EnabledNegativeTransitionMatch` | `tupleToMatch(Tuple t)`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `countMatches, countMatches, emptyArray, forEachMatch, forEachMatch, forOneArbitraryMatch, forOneArbitraryMatch, getAllMatches, getAllMatches, getAllValues, getAllValues, getCapabilities, getEngine, getOneArbitraryMatch, getOneArbitraryMatch, getParameterNames, getPatternName, getPositionOfParameter, getSpecification, hasMatch, matchToArray, newEmptyMatch, newMatch, rawAccumulateAllValues, rawCountMatches, rawForEachMatch, rawForOneArbitraryMatch, rawGetAllMatches, rawGetAllValues, rawGetOneArbitraryMatch, rawHasMatch, setBackend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### on

          public static EnabledNegativeTransitionMatcher on(ViatraQueryEngine engine)
                                                     throws ViatraQueryException

      Initializes the pattern matcher within an existing VIATRA Query engine. If the pattern matcher is already constructed in the engine, only a light-weight reference is returned. The match set will be incrementally refreshed upon updates.
      Parameters:
        `engine` - the existing VIATRA Query engine in which this matcher will be created.
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation

    - #### create

          public static EnabledNegativeTransitionMatcher create()
                                                         throws ViatraQueryException

      Returns:
        an initialized matcher
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation
      No Reference:
        This method is for internal matcher initialization by the framework, do not call it manually.

    - #### getAllMatches

          public java.util.Collection<EnabledNegativeTransitionMatch> getAllMatches(NegativeTransition pTransition,
                                                                                    EventToken pEventToken,
                                                                                    Event pEvent,
                                                                                    Automaton pAutomaton)

      Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pEventToken` - the fixed value of pattern parameter eventToken, or null if not bound.
        `pEvent` - the fixed value of pattern parameter event, or null if not bound.
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
      Returns:
        matches represented as a EnabledNegativeTransitionMatch object.

    - #### getOneArbitraryMatch

          public EnabledNegativeTransitionMatch getOneArbitraryMatch(NegativeTransition pTransition,
                                                                     EventToken pEventToken,
                                                                     Event pEvent,
                                                                     Automaton pAutomaton)

      Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pEventToken` - the fixed value of pattern parameter eventToken, or null if not bound.
        `pEvent` - the fixed value of pattern parameter event, or null if not bound.
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
      Returns:
        a match represented as a EnabledNegativeTransitionMatch object, or null if no match is found.

    - #### hasMatch

          public boolean hasMatch(NegativeTransition pTransition,
                                  EventToken pEventToken,
                                  Event pEvent,
                                  Automaton pAutomaton)

      Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
      Parameters:
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pEventToken` - the fixed value of pattern parameter eventToken, or null if not bound.
        `pEvent` - the fixed value of pattern parameter event, or null if not bound.
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
      Returns:
        true if the input is a valid (partial) match of the pattern.

    - #### countMatches

          public int countMatches(NegativeTransition pTransition,
                                  EventToken pEventToken,
                                  Event pEvent,
                                  Automaton pAutomaton)

      Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pEventToken` - the fixed value of pattern parameter eventToken, or null if not bound.
        `pEvent` - the fixed value of pattern parameter event, or null if not bound.
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
      Returns:
        the number of pattern matches found.

    - #### forEachMatch

          public void forEachMatch(NegativeTransition pTransition,
                                   EventToken pEventToken,
                                   Event pEvent,
                                   Automaton pAutomaton,
                                   IMatchProcessor<? super EnabledNegativeTransitionMatch> processor)

      Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
      Parameters:
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pEventToken` - the fixed value of pattern parameter eventToken, or null if not bound.
        `pEvent` - the fixed value of pattern parameter event, or null if not bound.
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
        `processor` - the action that will process each pattern match.

    - #### forOneArbitraryMatch

          public boolean forOneArbitraryMatch(NegativeTransition pTransition,
                                              EventToken pEventToken,
                                              Event pEvent,
                                              Automaton pAutomaton,
                                              IMatchProcessor<? super EnabledNegativeTransitionMatch> processor)

      Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pEventToken` - the fixed value of pattern parameter eventToken, or null if not bound.
        `pEvent` - the fixed value of pattern parameter event, or null if not bound.
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
        `processor` - the action that will process the selected match.
      Returns:
        true if the pattern has at least one match with the given parameter values, false if the processor was not invoked

    - #### newMatch

          public EnabledNegativeTransitionMatch newMatch(NegativeTransition pTransition,
                                                         EventToken pEventToken,
                                                         Event pEvent,
                                                         Automaton pAutomaton)

      Returns a new (partial) match. This can be used e.g. to call the matcher with a partial match.

      The returned match will be immutable. Use `BaseMatcher.newEmptyMatch()` to obtain a mutable match object.

      Parameters:
        `pTransition` - the fixed value of pattern parameter transition, or null if not bound.
        `pEventToken` - the fixed value of pattern parameter eventToken, or null if not bound.
        `pEvent` - the fixed value of pattern parameter event, or null if not bound.
        `pAutomaton` - the fixed value of pattern parameter automaton, or null if not bound.
      Returns:
        the (partial) match object.

    - #### rawAccumulateAllValuesOftransition

          protected java.util.Set<NegativeTransition> rawAccumulateAllValuesOftransition(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for transition.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftransition

          public java.util.Set<NegativeTransition> getAllValuesOftransition()

      Retrieve the set of values that occur in matches for transition.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftransition

          public java.util.Set<NegativeTransition> getAllValuesOftransition(EnabledNegativeTransitionMatch partialMatch)

      Retrieve the set of values that occur in matches for transition.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftransition

          public java.util.Set<NegativeTransition> getAllValuesOftransition(EventToken pEventToken,
                                                                            Event pEvent,
                                                                            Automaton pAutomaton)

      Retrieve the set of values that occur in matches for transition.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOfeventToken

          protected java.util.Set<EventToken> rawAccumulateAllValuesOfeventToken(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for eventToken.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfeventToken

          public java.util.Set<EventToken> getAllValuesOfeventToken()

      Retrieve the set of values that occur in matches for eventToken.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfeventToken

          public java.util.Set<EventToken> getAllValuesOfeventToken(EnabledNegativeTransitionMatch partialMatch)

      Retrieve the set of values that occur in matches for eventToken.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfeventToken

          public java.util.Set<EventToken> getAllValuesOfeventToken(NegativeTransition pTransition,
                                                                    Event pEvent,
                                                                    Automaton pAutomaton)

      Retrieve the set of values that occur in matches for eventToken.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOfevent

          protected java.util.Set<Event> rawAccumulateAllValuesOfevent(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for event.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfevent

          public java.util.Set<Event> getAllValuesOfevent()

      Retrieve the set of values that occur in matches for event.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfevent

          public java.util.Set<Event> getAllValuesOfevent(EnabledNegativeTransitionMatch partialMatch)

      Retrieve the set of values that occur in matches for event.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfevent

          public java.util.Set<Event> getAllValuesOfevent(NegativeTransition pTransition,
                                                          EventToken pEventToken,
                                                          Automaton pAutomaton)

      Retrieve the set of values that occur in matches for event.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOfautomaton

          protected java.util.Set<Automaton> rawAccumulateAllValuesOfautomaton(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for automaton.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfautomaton

          public java.util.Set<Automaton> getAllValuesOfautomaton()

      Retrieve the set of values that occur in matches for automaton.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfautomaton

          public java.util.Set<Automaton> getAllValuesOfautomaton(EnabledNegativeTransitionMatch partialMatch)

      Retrieve the set of values that occur in matches for automaton.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfautomaton

          public java.util.Set<Automaton> getAllValuesOfautomaton(NegativeTransition pTransition,
                                                                  EventToken pEventToken,
                                                                  Event pEvent)

      Retrieve the set of values that occur in matches for automaton.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### tupleToMatch

          protected EnabledNegativeTransitionMatch tupleToMatch(Tuple t)

      Specified by:
        `tupleToMatch` in class `BaseMatcher<EnabledNegativeTransitionMatch>`

    - #### arrayToMatch

          protected EnabledNegativeTransitionMatch arrayToMatch(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to an immutable Match object.
      Specified by:
        `arrayToMatch` in class `BaseMatcher<EnabledNegativeTransitionMatch>`

    - #### arrayToMatchMutable

          protected EnabledNegativeTransitionMatch arrayToMatchMutable(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to a mutable Match object.
      Specified by:
        `arrayToMatchMutable` in class `BaseMatcher<EnabledNegativeTransitionMatch>`

    - #### querySpecification

          public static IQuerySpecification<EnabledNegativeTransitionMatcher> querySpecification()
                                                                                          throws ViatraQueryException

      Returns:
        the singleton instance of the query specification of this pattern
      Throws:
        `ViatraQueryException` - if the pattern definition could not be loaded